=== debian/changelog ===
gnucash (1:5.8-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Add libwebkit2gtk-4.0-dev (>= 2.34.6~) as alternative B-D.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 07 Aug 2024 18:36:04 -0700

gnucash (1:5.8-1) unstable; urgency=medium

  * New upstream release.
    + fixed FTBFS in "gtest-gnc-int128.cpp" (Closes: #1077415).

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 01 Aug 2024 19:40:30 +1000
