## gnucash 5.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,9 +6,17 @@
 if (POLICY CMP0094)
   cmake_policy(SET CMP0094 NEW)
 endif()
+# CMake 3.30+ Use Boost's builtin BoostConfig.cmake instead of
+# FindBoost, the latter of which is removed. Setting this policy to OLD
+# temporarily restores it. BoostConfig.cmake was introduced in Boost
+# 1.70.  A fair number of distros are still shipping Boost 1.69 in
+# "legacy" versions so make it OLD for the 5.x series and NEW for 6.x.
+if (POLICY CMP0167)
+  cmake_policy(SET CMP0167 OLD)
+endif()
 
 project (gnucash
-    VERSION 5.8
+    VERSION 5.9
 )
 
 enable_testing()
@@ -266,15 +274,3 @@
     message (WARNING "Gettext version 0.20 or more recent is required to translate the 'developer_name' tag in gnucash.appdata.xml. All but that tag will be translated in the generated file.")
     if(BUILD_GNUCASH_POT)
         # Only emit warning if potfile generation was enabled otherwise
-        message (WARNING "Gettext version 0.20 or more recent is required to extract all translatable strings. Potfile generation will be disabled.")
-    endif()
-    set (BUILD_GNUCASH_POT OFF)
-endif()
-
-find_path (LIBINTL_INCLUDE_PATH NAMES libintl.h
-		  PATHS /usr/include /opt/gnome/include)
-find_library (LIBINTL_LIBRARY NAMES intl)
-
-# HELP
-if (WIN32)
-  message(STATUS "Looking for htmlhelp.h and htmlhelp.a")
