=== debian/changelog ===
gnucash (1:5.9-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 03 Oct 2024 16:53:29 -0700
